﻿Imports LoadXMLTest
Imports System.IO
Imports System.Reflection
Imports System.Data.SqlClient
Imports System.Xml

Public Class Form1

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load


    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim ds As New DataSet()
        ds.ReadXml(Path.Combine(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location), "../../Data.xml"))

        Dim sw As New Stopwatch()
        sw.Start()

        If ds.Tables(0).Rows.Count > 0 Then
            ReportViewer1.Visible = True

            Dim report As New Report1()
            report.DataSource = ds.Tables(0)

            Dim source As New Telerik.Reporting.InstanceReportSource()
            source.ReportDocument = report

            ReportViewer1.ReportSource = source
        End If
        sw.Stop()
        Label1.Text = "Milliseconds: " & sw.ElapsedMilliseconds.ToString()
        ReportViewer1.RefreshReport()
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click

        Dim sql As String = "SELECT [XMLContent] FROM [XMLvsSQL].[dbo].[TableXML]"
        Dim connectionString As String = "Data Source=(local)\SQLEXPRESS;Initial Catalog=XMLvsSQL;Integrated Security=True"
        Dim adapter As New SqlDataAdapter(sql, connectionString)
        Dim dataTable As New DataTable()
        adapter.Fill(dataTable)

        Dim xmlDocument As New XmlDocument()
        xmlDocument.LoadXml(dataTable.Rows(0)("XMLContent").ToString())


        Dim ds As New DataSet
        Dim xNodeList As Xml.XmlNodeList = xmlDocument.GetElementsByTagName("Row")
        Dim xReader As Xml.XmlTextReader
        Dim x As Integer
        For x = 0 To xNodeList.Count - 1
            xReader = New Xml.XmlTextReader(xNodeList.Item(x).OuterXml, Xml.XmlNodeType.Element, New Xml.XmlParserContext(Nothing, Nothing, Nothing, Xml.XmlSpace.None))
            ds.ReadXml(xReader, XmlReadMode.InferSchema)
        Next x

        Dim sw As New Stopwatch()
        sw.Start()

        If ds.Tables(0).Rows.Count > 0 Then
            ReportViewer1.Visible = True

            Dim report As New Report1()
            report.DataSource = ds.Tables(0)

            Dim source As New Telerik.Reporting.InstanceReportSource()
            source.ReportDocument = report

            ReportViewer1.ReportSource = source
        End If
        sw.Stop()
        Label2.Text = "Milliseconds: " & sw.ElapsedMilliseconds.ToString()
        ReportViewer1.RefreshReport()
    End Sub
End Class
